;##########################################################################
.386
.model flat, stdcall
option casemap:none
title Anaglyph
;##########################################################################
include C:\masm32\include\windows.inc
include C:\masm32\include\kernel32.inc
include C:\masm32\include\user32.inc
include C:\masm32\include\comdlg32.inc
include C:\masm32\include\shell32.inc
include C:\masm32\include\ole32.inc
include lib\ijl15.inc
includelib C:\masm32\lib\kernel32.lib
includelib C:\masm32\lib\user32.lib
includelib C:\masm32\lib\comdlg32.lib
includelib C:\masm32\lib\shell32.lib
includelib C:\masm32\lib\ole32.lib
includelib lib\ijl15.lib
;##########################################################################
szText MACRO Name, Text:VARARG
LOCAL lbl
	jmp	lbl
	Name	db	Text, 0
lbl:
ENDM
m2m MACRO M1, M2
	push	M2
	pop	M1
ENDM
m2mx MACRO M1, M2
	mov	eax, M2
	mov	M1, eax
ENDM
return MACRO RETVALUE
	mov	eax, RETVALUE
	ret
ENDM
iif MACRO condition, if_true, if_false, return
	.if condition
		mov	return, if_true
	.else
		mov	return, if_false
	.endif
ENDM
iifs MACRO condition, if_true, if_false, return
	mov	return, if_false
	.if condition
		mov	return, if_true
	.endif
ENDM
;##########################################################################
;##########################################################################
	imgSize		equ		320*240*3
;##########################################################################
WndProc		PROTO	:DWORD,:DWORD,:DWORD,:DWORD
ijlOpenJPEG	PROTO	:PTR BYTE,:DWORD
LoadList	PROTO	:DWORD
CheckSlash	PROTO	:PTR BYTE
anaglyph	PROTO
ustr2dw		PROTO
DoEvents	PROTO
ErrorHandler	PROTO C	:DWORD,:DWORD,:DWORD,:DWORD
ExceptionFilter	PROTO	:DWORD
;##########################################################################
.const
	szAppTitle		db			"Anaglyph", 0
	szMsgAbout		db			"Anaglyph", 13, 10
				db			"Version 1.0.1", 13, 10
				db			"Coded by comrade", 13, 10
				db			"comrade2k@hotmail.com", 13, 10
				db			"Web: http://www.comrade64.com/", 13, 10
				db			"http://comrade64.cjb.net/", 13, 10
				db			"IRC: #coders on EFnet", 0
	szMenuAbout		db			"&About Anaglyph...", 0

	szError			db			"Error", 0
	szErrorNoMatch		db			"The number of images in the left and right cameras do not match.", 0
	szErrorNoProc		db			"No images to process.", 0
	szErrorNoDest		db			"No destination directory specified.", 0
	szErrorNoRes		db			"Invalid resolution.", 0

	szErrorThread		db			"Error at %08Xh", 13, 10, "Registers:", 13, 10, "eax = %08Xh ebx = %08Xh ecx = %08Xh", 13, 10, "edx = %08Xh esp = %08Xh ebp = %08Xh", 13, 10, "esi = %08Xh edi = %08Xh", 13, 10, 13, 10, "Recovering...", 0
	szErrorFinal		db			"Error at %08Xh", 13, 10, "Quitting...", 0

	szFormatJPEG		db			"JPEG", 0
	szFormatBitmap		db			"Bitmap", 0

	szPriorityClassRealTime	db			"Real-time", 0
	szPriorityClassHigh	db			"High", 0
	szPriorityClassNormal	db			"Normal", 0
	szPriorityClassIdle	db			"Idle", 0

	szThreadPriorityTimeCrt	db			"Time-critical", 0
	szThreadPriorityHighest	db			"Highest", 0
	szThreadPriorityHigh	db			"High", 0
	szThreadPriorityNormal	db			"Normal", 0
	szThreadPriorityLow	db			"Low", 0
	szThreadPriorityLowest	db			"Lowest", 0
	szThreadPriorityIdle	db			"Idle", 0

	szStatusReady		db			"Ready", 0
	szStatusDone		db			"Done in %lu minutes and %lu seconds", 0

	szOutputFormat		db			"out-%04lu.bmp", 0
	szFileFilter		db			"JPEG Images (*.jpg;*.jpeg)", 0, "*.jpeg;*.jpg", 0, "All Files (*.*)", 0, "*.*", 0, 0
;##########################################################################
.data
;##########################################################################
.data?
	hIcon			dd			?
	hIconOpen		dd			?
	hProcess		dd			?
	hThread			dd			?
	dwOldPriorityClass	dd			?
	dwOldThreadPriority	dd			?
	dwTime			dd			?
	hMemoryBitmap		dd			?
	dwBitmapDest		dd			?
	dwBitmapSource		dd			?
	dwBitmapBlend		dd			?
	dwBytesWritten		dd			?
	seh			dd			6 dup (?)

	szMessage		db			256 dup (?)

	data_start		equ			$
	szSourceDir		db			MAX_PATH dup (?)
	szBlendDir		db			MAX_PATH dup (?)
	szDestDir		db			MAX_PATH dup (?)
	szResolution		db			64 dup (?)
	szFileName		db			256*64 dup (?)
	szImage			db			256 dup (?)
	dwResWidth		dd			?
	dwResHeight		dd			?
	dwResLine		dd			?
	dwResSize		dd			?
	ofn			OPENFILENAME		<>
	mbp			MSGBOXPARAMS		<>
	bi			BROWSEINFO		<>
	bmfh			BITMAPFILEHEADER	<>
	bmi			BITMAPINFO		<>
	jcp			JPEG_CORE_PROPERTIES	<>
	data_size		equ			$ - data_start
;##########################################################################
.code
start:	invoke	SetUnhandledExceptionFilter, ADDR ExceptionFilter
	push	edi
	xor	eax, eax
	mov	ecx, data_size shr 2
	mov	edi, data_start
	rep	stosd
	IF data_size AND 3
		mov	edi, data_start
		mov	ecx, data_size and 3
		rep	stosb
	ENDIF
	pop	edi
	invoke	GetModuleHandle, 0
	mov	[ofn.hInstance], eax
	mov	[mbp.hInstance], eax
	invoke	DialogBoxParam, eax, 100, 0, ADDR WndProc, eax
	invoke	ExitProcess, eax
;#########################################################################
WndProc proc hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	.if [uMsg]==WM_INITDIALOG
		mov	eax, [hWnd]
		mov	[ofn.lStructSize], sizeof ofn
		mov	[ofn.lpstrFilter], OFFSET szFileFilter
		mov	[ofn.lpstrFile], OFFSET szFileName
		mov	[ofn.nMaxFile], sizeof szFileName
		mov	[ofn.Flags], OFN_ALLOWMULTISELECT OR OFN_EXPLORER
		mov	[ofn.lpstrDefExt], OFFSET szFileFilter+35
		mov	[ofn.hwndOwner], eax
		mov	[mbp.hwndOwner], eax
		mov	[bi.hwndOwner], eax
		invoke	GetSystemMenu, eax, 0
		push	OFFSET szMenuAbout
		push	10
		push	MFT_STRING
		push	eax
		invoke	AppendMenu, eax, MFT_SEPARATOR, 0, 0
		call	AppendMenu
		invoke	LoadIcon, [lParam], 2
		mov	[hIcon], eax
		invoke	SendMessage, [hWnd], WM_SETICON, 1, eax
		invoke	LoadImage, [lParam], 3, IMAGE_ICON, 16, 16, 0
		mov	[hIconOpen], eax
		mov	ecx, [hWnd]
		push	eax
		push	IMAGE_ICON
		push	BM_SETIMAGE
		push	107
		push	ecx
		push	eax
		push	IMAGE_ICON
		push	BM_SETIMAGE
		push	104
		push	ecx
		invoke	SendDlgItemMessage, ecx, 102, BM_SETIMAGE, IMAGE_ICON, eax
		call	SendDlgItemMessage	;invoke	SendDlgItemMessage, [hWnd], 104, BM_SETIMAGE, 0, eax
		call	SendDlgItemMessage	;invoke	SendDlgItemMessage, [hWnd], 107, BM_SETIMAGE, 0, eax

		invoke	SendDlgItemMessage, [hWnd], 108, CB_ADDSTRING, 0, ADDR szFormatJPEG
		invoke	SendDlgItemMessage, [hWnd], 108, CB_SETCURSEL, 0, eax
		invoke	SendDlgItemMessage, [hWnd], 108, CB_ADDSTRING, 0, ADDR szFormatBitmap

		invoke	SendDlgItemMessage, [hWnd], 109, CB_ADDSTRING, 0, ADDR szPriorityClassRealTime
		invoke	SendDlgItemMessage, [hWnd], 109, CB_SETITEMDATA, eax, REALTIME_PRIORITY_CLASS
		invoke	SendDlgItemMessage, [hWnd], 109, CB_ADDSTRING, 0, ADDR szPriorityClassHigh
		invoke	SendDlgItemMessage, [hWnd], 109, CB_SETITEMDATA, eax, HIGH_PRIORITY_CLASS
		invoke	SendDlgItemMessage, [hWnd], 109, CB_ADDSTRING, 0, ADDR szPriorityClassNormal
		push	0
		push	eax
		push	CB_SETCURSEL
		push	109
		push	[hWnd]
		invoke	SendDlgItemMessage, [hWnd], 109, CB_SETITEMDATA, eax, NORMAL_PRIORITY_CLASS
		call	SendDlgItemMessage
		invoke	SendDlgItemMessage, [hWnd], 109, CB_ADDSTRING, 0, ADDR szPriorityClassIdle
		invoke	SendDlgItemMessage, [hWnd], 109, CB_SETITEMDATA, eax, IDLE_PRIORITY_CLASS

		invoke	SendDlgItemMessage, [hWnd], 110, CB_ADDSTRING, 0, ADDR szThreadPriorityTimeCrt
		invoke	SendDlgItemMessage, [hWnd], 110, CB_SETITEMDATA, eax, THREAD_PRIORITY_TIME_CRITICAL
		invoke	SendDlgItemMessage, [hWnd], 110, CB_ADDSTRING, 0, ADDR szThreadPriorityHighest
		invoke	SendDlgItemMessage, [hWnd], 110, CB_SETITEMDATA, eax, THREAD_PRIORITY_HIGHEST
		invoke	SendDlgItemMessage, [hWnd], 110, CB_ADDSTRING, 0, ADDR szThreadPriorityHigh
		invoke	SendDlgItemMessage, [hWnd], 110, CB_SETITEMDATA, eax, THREAD_PRIORITY_ABOVE_NORMAL
		invoke	SendDlgItemMessage, [hWnd], 110, CB_ADDSTRING, 0, ADDR szThreadPriorityNormal
		push	0
		push	eax
		push	CB_SETCURSEL
		push	110
		push	[hWnd]
		invoke	SendDlgItemMessage, [hWnd], 110, CB_SETITEMDATA, eax, THREAD_PRIORITY_NORMAL
		call	SendDlgItemMessage
		invoke	SendDlgItemMessage, [hWnd], 110, CB_ADDSTRING, 0, ADDR szThreadPriorityLow
		invoke	SendDlgItemMessage, [hWnd], 110, CB_SETITEMDATA, eax, THREAD_PRIORITY_BELOW_NORMAL
		invoke	SendDlgItemMessage, [hWnd], 110, CB_ADDSTRING, 0, ADDR szThreadPriorityLowest
		invoke	SendDlgItemMessage, [hWnd], 110, CB_SETITEMDATA, eax, THREAD_PRIORITY_LOWEST
		invoke	SendDlgItemMessage, [hWnd], 110, CB_ADDSTRING, 0, ADDR szThreadPriorityIdle
		invoke	SendDlgItemMessage, [hWnd], 110, CB_SETITEMDATA, eax, THREAD_PRIORITY_IDLE

		inc	eax
		ret
	.elseif [uMsg]==WM_COMMAND
		mov	eax, [wParam]
		.if ax==102
			push	edi
			xor	eax, eax
			mov	ecx, sizeof szFileName shr 2
			mov	edi, OFFSET szFileName
			rep	stosd
			pop	edi
			invoke	GetOpenFileName, ADDR ofn
			test	eax, eax
			.if !zero?
				push	esi
				movzx	ecx, [ofn.nFileOffset]
				push	edi
				mov	esi, OFFSET szFileName
				mov	edi, OFFSET szSourceDir
				rep	movsb
				mov	byte ptr [edi], 0
				pop	edi
				pop	esi
				invoke	GetDlgItem, [hWnd], 103
				invoke	LoadList, eax
			.endif
		.elseif ax==104
			push	edi
			xor	eax, eax
			mov	ecx, sizeof szFileName shr 2
			mov	edi, OFFSET szFileName
			rep	stosd
			pop	edi
			invoke	GetOpenFileName, ADDR ofn
			test	eax, eax
			.if !zero?
				push	esi
				movzx	ecx, [ofn.nFileOffset]
				push	edi
				mov	esi, OFFSET szFileName
				mov	edi, OFFSET szBlendDir
				rep	movsb
				mov	byte ptr [edi], 0
				pop	edi
				pop	esi
				invoke	GetDlgItem, [hWnd], 105
				invoke	LoadList, eax
			.endif
		.elseif ax==106
			shr	eax, 16
			.if ax==EN_CHANGE
				invoke	GetWindowTextLength, [lParam]
				push	eax
				invoke	GetDlgItem, [hWnd], 120
				push	eax
				call	EnableWindow
			.endif
		.elseif ax==107
			invoke	SHBrowseForFolder, ADDR bi
			test	eax, eax
			.if !zero?
				push	eax
				invoke	SHGetPathFromIDList, eax, ADDR szDestDir
				call	CoTaskMemFree
				invoke	CheckSlash, ADDR szDestDir
				invoke	SetDlgItemText, [hWnd], 106, edx
			.endif
		.elseif ax==120
			invoke	SendDlgItemMessage, [hWnd], 103, LB_GETCOUNT, 0, 0
			push	eax
			invoke	SendDlgItemMessage, [hWnd], 105, LB_GETCOUNT, 0, 0
			pop	ecx
			cmp	eax, ecx
			.if !zero?
				push	MB_OK OR MB_ICONHAND OR MB_APPLMODAL
				push	OFFSET szError
				push	OFFSET szErrorNoMatch
				push	[hWnd]
				push	OFFSET @@quit
				jmp	MessageBox
				;invoke	MessageBox, [hWnd], ADDR szErrorNoMatch, ADDR szError, MB_OK OR MB_ICONHAND OR MB_APPLMODAL
			.endif
			test	eax, eax
			.if zero?
				push	MB_OK OR MB_ICONHAND OR MB_APPLMODAL
				push	OFFSET szError
				push	OFFSET szErrorNoProc
				push	[hWnd]
				push	OFFSET @@quit
				jmp	MessageBox
				;invoke	MessageBox, [hWnd], ADDR szErrorNoProc, ADDR szError, MB_OK OR MB_ICONHAND OR MB_APPLMODAL
			.endif
			invoke	GetDlgItemText, [hWnd], 106, ADDR szDestDir, sizeof szDestDir
			test	eax, eax
			.if zero?
				push	MB_OK OR MB_ICONHAND OR MB_APPLMODAL
				push	OFFSET szError
				push	OFFSET szErrorNoDest
				push	[hWnd]
				push	OFFSET @@quit
				jmp	MessageBox
				;invoke	MessageBox, [hWnd], ADDR szErrorNoDest, ADDR szError, MB_OK OR MB_ICONHAND OR MB_APPLMODAL
			.endif
			invoke	GetDlgItemText, [hWnd], 111, ADDR szResolution, sizeof szResolution
			test	eax, eax
			.if zero?
			@@bres:	push	MB_OK OR MB_ICONHAND OR MB_APPLMODAL
				push	OFFSET szError
				push	OFFSET szErrorNoRes
				push	[hWnd]
				push	OFFSET @@quit
				jmp	MessageBox
				;invoke	MessageBox, [hWnd], ADDR szErrorNoRes, ADDR szError, MB_OK OR MB_ICONHAND OR MB_APPLMODAL
			.endif
			push	esi
			mov	esi, OFFSET szResolution
			call	ustr2dw
			mov	[dwResWidth], eax
			inc	esi
			call	ustr2dw
			mov	[dwResHeight], eax
			pop	esi
			test	eax, eax
			mov	ecx, [dwResWidth]
			jz	@@bres
			test	ecx, ecx
			jz	@@bres

			assume	fs:nothing
			push	OFFSET ErrorHandler
			push	FS:[0]
			mov	[seh], esp
			mov	[seh+4], ebp
			mov	[seh+8], ebx
			mov	[seh+12], esi
			mov	[seh+16], edi
			mov	[seh+20], OFFSET @@safe
			mov	FS:[0], esp
			; critical code
			call	GetCurrentProcess
			mov	[hProcess], eax
			invoke	GetPriorityClass, eax
			mov	[dwOldPriorityClass], eax
			invoke	SendDlgItemMessage, [hWnd], 109, CB_GETCURSEL, 0, 0
			invoke	SendDlgItemMessage, [hWnd], 109, CB_GETITEMDATA, eax, 0
			invoke	SetPriorityClass, [hProcess], eax
			call	GetCurrentThread
			mov	[hThread], eax
			invoke	GetThreadPriority, eax
			mov	[dwOldThreadPriority], eax
			invoke	SendDlgItemMessage, [hWnd], 110, CB_GETCURSEL, 0, 0
			invoke	SendDlgItemMessage, [hWnd], 110, CB_GETITEMDATA, eax, 0
			invoke	SetThreadPriority, [hThread], eax
			call	GetTickCount
			mov	[dwTime], eax

			mov	ecx, [dwResWidth]
			mov	eax, [dwResHeight]
			lea	ecx, [ecx*2+ecx]
			mov	[dwResLine], ecx
			mul	ecx
			mov	[dwResSize], eax
			lea	eax, [eax*2+eax]
			invoke	GlobalAlloc, GMEM_MOVEABLE, eax
			mov	[hMemoryBitmap], eax
			invoke	GlobalLock, eax
			mov	[dwBitmapDest], eax
			add	eax, [dwResSize]
			mov	[dwBitmapSource], eax
			add	eax, [dwResSize]
			mov	[dwBitmapBlend], eax
			invoke	SendDlgItemMessage, [hWnd], 103, LB_GETCOUNT, 0, 0
			mov	ecx, eax
		@@pimg:	push	ecx
			mov	eax, OFFSET szImage
			mov	edx, [hWnd]
			dec	ecx
			push	[dwBitmapSource]
			push	eax

			push	0
			push	ecx
			push	LB_SETCURSEL
			push	103
			push	edx
			invoke	SendDlgItemMessage, edx, 103, LB_GETTEXT, ecx, eax
			call	SendDlgItemMessage	;invoke	SendDlgItemMessage, [hWnd], 103, LB_SETCURSEL, ecx, 0
			invoke	SetCurrentDirectory, ADDR szSourceDir
			call	ijlOpenJPEG
			test	eax, eax
			jz	@@nimg
			mov	eax, OFFSET szImage
			mov	ecx, [esp]
			mov	edx, [hWnd]
			push	[dwBitmapBlend]
			push	eax
			dec	ecx

			push	0
			push	ecx
			push	LB_SETCURSEL
			push	105
			push	edx
			invoke	SendDlgItemMessage, edx, 105, LB_GETTEXT, ecx, eax
			call	SendDlgItemMessage	;invoke	SendDlgItemMessage, [hWnd], 105, LB_SETCURSEL, ecx, 0
			call	DoEvents
			invoke	SetCurrentDirectory, ADDR szBlendDir
			call	ijlOpenJPEG
			test	eax, eax
			jz	@@nimg

			push	esi
			push	edi
			push	ebx
			mov	esi, [dwBitmapSource]
			mov	ebx, [dwBitmapBlend]
			mov	edi, [dwBitmapDest]
			mov	ecx, [dwResSize]
			call	anaglyph
			pop	ebx
			pop	edi
			pop	esi
			mov	[bmfh.bfType], "MB"
			mov	[bmfh.bfSize], imgSize+sizeof bmfh+sizeof bmi.bmiHeader
			mov	[bmfh.bfOffBits], sizeof bmfh+sizeof bmi.bmiHeader
			invoke	SetCurrentDirectory, ADDR szDestDir
			invoke	wsprintf, ADDR szImage, ADDR szOutputFormat, dword ptr [esp]
			xor	eax, eax
			invoke	CreateFile, ADDR szImage, GENERIC_WRITE, eax, eax, CREATE_ALWAYS, eax, eax
			push	eax
			invoke	WriteFile, eax, ADDR bmfh, sizeof bmfh+sizeof bmi.bmiHeader, ADDR dwBytesWritten, 0
			mov	eax, [dwBitmapDest]
			add	eax, [dwResSize]
			sub	eax, [dwResLine]
		@@wr_y:	push	eax
			invoke	WriteFile, [esp+20], eax, [dwResLine], ADDR dwBytesWritten, 0
			pop	eax
			sub	eax, [dwResLine]
			cmp	eax, [dwBitmapDest]
			jne	@@wr_y
			;invoke	WriteFile, [esp+16], [dwBitmapDest], [dwResSize], ADDR dwBytesWritten, 0
			call	CloseHandle

		@@nimg:	pop	ecx
			dec	ecx
			jnz	@@pimg
		@@safe:	mov	eax, [hMemoryBitmap]
			pop	FS:[0]
			mov	[esp], eax
			invoke	GlobalUnlock, eax
			call	GlobalFree
			invoke	SetPriorityClass, [hProcess], [dwOldPriorityClass]
			invoke	SetThreadPriority, [hThread], [dwOldThreadPriority]
			call	GetTickCount
			xor	edx, edx
			sub	eax, [dwTime]
			mov	ecx, 1000
			div	ecx
			xor	edx, edx
			mov	ecx, 60
			div	ecx
			invoke	wsprintf, ADDR szMessage, ADDR szStatusDone, eax, edx
			invoke	SetDlgItemText, [hWnd], 112, ADDR szMessage
		.elseif ax==121
		@@msga:	mov	[mbp.cbSize], sizeof mbp
			mov	[mbp.lpszText], OFFSET szMsgAbout
			mov	[mbp.lpszCaption], OFFSET szAppTitle
			mov	[mbp.dwStyle], MB_OK OR MB_APPLMODAL OR MB_USERICON
			mov	[mbp.lpszIcon], 2
			invoke	MessageBoxIndirect, ADDR mbp
		.elseif ax==122
			invoke	SendMessage, [hWnd], WM_CLOSE, 0, 0
		.endif
	.elseif [uMsg]==WM_SYSCOMMAND
		cmp	[wParam], 10
		je	@@msga
	.elseif [uMsg]==WM_VKEYTOITEM
		mov	eax, [wParam]
		.if ax==VK_DELETE
			invoke	SendMessage, [lParam], LB_GETCOUNT, 0, 0
			test	eax, eax
			jz	@@noit
			mov	ecx, eax
		@@deli:	push	ecx
			dec	ecx
			invoke	SendMessage, [lParam], LB_GETSEL, ecx, 0
			test	eax, eax
			.if !zero?
				mov	eax, [esp]
				dec	eax
				invoke	SendMessage, [lParam], LB_DELETESTRING, eax, 0
			.endif
			pop	ecx
			dec	ecx
			jnz	@@deli
		.endif
		xor	eax, eax
	@@noit:	dec	eax
		ret
	.elseif [uMsg]==WM_CLOSE
		invoke	EndDialog, [hWnd], 0
		invoke	DestroyIcon, [hIcon]
		invoke	DestroyIcon, [hIconOpen]
	.endif
@@quit:	xor	eax, eax
	ret
WndProc endp
;##########################################################################
ijlOpenJPEG proc pszFileName:PTR BYTE, dwBuffer:DWORD
	push	edi
	mov	ecx, (sizeof bmi+sizeof jcp) shr 2
	xor	eax, eax
	mov	edi, OFFSET bmi
	rep	stosd
	pop	edi
	invoke	ijlInit, ADDR jcp
	test	eax, eax
	jnz	@@err
	m2m	[jcp.JPGFile], [pszFileName]
	invoke	ijlRead, ADDR jcp, IJL_JFILE_READPARAMS
	test	eax, eax
	jnz	@@err
	.if [jcp.JPGChannels]==1
		mov	[jcp.JPGColor], IJL_G
	.elseif [jcp.JPGChannels]==3
		mov	[jcp.JPGColor], IJL_YCBCR
	.else
		mov	[jcp.DIBColor], IJL_OTHER
		mov	[jcp.JPGColor], IJL_OTHER
	.endif
	mov	[bmi.bmiHeader.biSize], sizeof bmi.bmiHeader
	mov	[bmi.bmiHeader.biPlanes], 1
	mov	[bmi.bmiHeader.biBitCount], 24
	mov	[bmi.bmiHeader.biCompression], BI_RGB
	mov	eax, [jcp.JPGWidth]
	mov	[jcp.DIBWidth], eax
	mov	[bmi.bmiHeader.biWidth], eax
	mov	eax, [jcp.JPGHeight]
	mov	[jcp.DIBHeight], eax
	mov	[bmi.bmiHeader.biHeight], eax
	mov	[jcp.DIBChannels], 3

	xor	edx, edx
	mov	eax, [jcp.DIBWidth]
	mov	ecx, sizeof DWORD
	div	ecx
	mov	[jcp.DIBPadBytes], edx

	xor	edx, edx
	mov	eax, [jcp.DIBWidth]
	mov	ecx, [jcp.DIBChannels]
	mul	ecx
	add	eax, [jcp.DIBPadBytes]
	mov	ecx, [jcp.DIBHeight]
	mul	ecx
	m2m	[jcp.DIBBytes], [dwBuffer]
	invoke	ijlRead, ADDR jcp, IJL_JFILE_READWHOLEIMAGE
	test	eax, eax
	jnz	@@err
	jmp	@@done
@@err:	invoke	ijlErrorStr, eax
	invoke	MessageBox, [ofn.hwndOwner], eax, ADDR szError, MB_OK OR MB_ICONHAND OR MB_APPLMODAL
	invoke	ijlFree, ADDR jcp
	xor	eax, eax
	ret
@@done:	invoke	ijlFree, ADDR jcp
	test	eax, eax
	jnz	@@err
	xor	eax, eax
	inc	eax
	ret
ijlOpenJPEG endp
;##########################################################################
LoadList proc hList:DWORD
	invoke	SendMessage, [hList], LB_RESETCONTENT, 0, 0
	movzx	eax, [ofn.nFileOffset]
	add	eax, OFFSET szFileName
@@next:	cmp	word ptr [eax], 0
	je	@@quit
	push	eax
	invoke	SendMessage, [hList], LB_ADDSTRING, 0, eax
	pop	eax
	inc	eax
@@chk:	cmp	byte ptr [eax-1], 0
	je	@@next
	inc	eax
	jmp	@@chk
	jmp	@@next
@@quit:	ret
LoadList endp
;##########################################################################
CheckSlash proc pszPath:PTR BYTE
	mov	edx, [pszPath]
	xor	eax, eax
@@cmp:	cmp	byte ptr [edx+eax], 0
	je	@@fnd
	inc	eax
	jmp	@@cmp
@@fnd:	cmp	byte ptr [edx+eax-1], "\"
	je	@@done
	mov	word ptr [edx+eax], "\"
	inc	eax
@@done:	ret
CheckSlash endp
;##########################################################################
anaglyph proc
	push	ebp
	mov	dword ptr [szImage], esp
@@redo:	mov	eax, [esi]
	mov	ebp, [ebx]
	mov	edx, [esi+3]
	mov	esp, [ebx+3]
	and	eax, 00FF0000h
	and	ebp, 0000FFFFh
	and	edx, 00FF0000h
	and	esp, 0000FFFFh
	or	eax, ebp
	or	edx, esp
	mov	[edi], eax
	mov	[edi+3], edx
	add	esi, 6
	add	ebx, 6
	add	edi, 6
	sub	ecx, 6
	jnz	@@redo
	mov	esp, dword ptr [szImage]
	pop	ebp
	ret
anaglyph endp
;#########################################################################
ustr2dw proc
	xor	eax, eax
	xor	edx, edx
	jmp	@@chkz
@@redo:	sub	dl, "0"
	mov	ecx, eax
	add	eax, eax
	shl	ecx, 3
	inc	esi
	add	eax, ecx
	add	eax, edx
@@chkz:	mov	dl, [esi]
	cmp	dl, "0"
	jb	@@quit
	cmp	dl, "9"
	ja	@@quit
	test	dl, dl
	jnz	@@redo
@@quit:	ret
ustr2dw endp
;#########################################################################
DoEvents proc
	LOCAL msg:MSG
@@peek:	xor	eax, eax
	invoke	PeekMessage, ADDR msg, eax, eax, eax, PM_REMOVE
	test	eax, eax
	jz	@@done
	lea	eax, [msg]
	push	eax
	invoke	TranslateMessage, eax
	call	DispatchMessage
	jmp	@@peek
@@done:	ret
DoEvents endp
;##########################################################################
ErrorHandler proc C lpExcept:DWORD, lpFrame:DWORD, lpContext:DWORD, lpDispatch:DWORD
	mov	eax, [lpExcept]
	mov	ecx, [lpContext]
	invoke	wsprintf, ADDR szMessage, ADDR szErrorThread, [eax][EXCEPTION_RECORD.ExceptionAddress], [ecx][CONTEXT.regEax], [ecx][CONTEXT.regEbx], [ecx][CONTEXT.regEcx], [ecx][CONTEXT.regEdx], [ecx][CONTEXT.regEsp], [ecx][CONTEXT.regEbp], [ecx][CONTEXT.regEsi], [ecx][CONTEXT.regEdi]
	invoke	MessageBox, [mbp.hwndOwner], ADDR szMessage, ADDR szError, MB_OK OR MB_ICONHAND OR MB_APPLMODAL

	mov	eax, [lpContext]
	m2m	[eax][CONTEXT.regEsp], [seh]
	m2m	[eax][CONTEXT.regEbp], [seh+4]
	m2m	[eax][CONTEXT.regEbx], [seh+8]
	m2m	[eax][CONTEXT.regEsi], [seh+12]
	m2m	[eax][CONTEXT.regEdi], [seh+16]
	m2m	[eax][CONTEXT.regEip], [seh+20]

	xor	eax, eax	; continue execution
	ret
ErrorHandler endp
;##########################################################################
ExceptionFilter proc lpExcept:DWORD
	mov	eax, [lpExcept]
	invoke	wsprintf, ADDR szMessage, ADDR szErrorFinal, [eax][EXCEPTION_RECORD.ExceptionAddress]
	invoke	MessageBox, [mbp.hwndOwner], ADDR szMessage, ADDR szError, MB_OK OR MB_ICONHAND OR MB_APPLMODAL
	mov	eax, [hMemoryBitmap]
	push	eax
	invoke	GlobalUnlock, eax
	call	GlobalFree
	invoke	EndDialog, [mbp.hwndOwner], eax
	invoke	DestroyIcon, [hIcon]
	invoke	ExitProcess, 0
	xor	eax, eax
	inc	eax		; EXCEPTION_EXECUTE_HANDLER
	ret
ExceptionFilter endp
;##########################################################################
;##########################################################################
;##########################################################################
end start